import Component from '@ember/component';
import injectService from 'ember-service/inject';
import { computed } from '@ember/object';
import { A } from '@ember/array';
import EmberObject from '@ember/object';

export default Component.extend({
    store: injectService(),
    entityType: '',
    entityKey: '',
    selectedEntities: [],
    entities: [],
    tableColumns: computed(function() {
        var col = A([
            EmberObject.create({
            propertyName: "id",
            title: "id"
        }),
        EmberObject.create({
            propertyName: this.get('entityKey'),
            title: this.get('entityKey')
        })
        ]);
        return col;
    }),
  init(){
    this._super(...arguments);
    this._getEntities();
  },

  _getEntities() {
    this.get('store').findAll(this.get('entityType')).then((entities) => {
      // because this is async you need to guard against the component 
      // being destroyed before the api call has finished because 
      // because `this.set` will throw an error.
      if (this.isDestroyed) { return; } 

      this.set('entities', entities);
        }
    )}
})
